'２分割の設定ﾌﾟﾛｸﾞﾗﾑ

Public Class SolDDat5

    Dim KindAxis As Integer     '指定座標軸（1:X軸、2:Y軸、3:Z軸）

    Dim Vstd As Single          '指定座標値

    Private Sub ElemPnumReverse3()
        '要素の節点番号の反転（立体）
        Dim i, j, jb As Integer
        Dim nbuf(20) As Integer

        If KindElem = 0 Then
            For i = 1 To Nelem
                For j = 1 To 20
                    nbuf(j) = NNelem(i, j)
                Next j
                For j = 1 To 7 Step 2
                    jb = 8 - j
                    NNelem(i, j) = nbuf(jb)
                    jb = jb - 1
                    If jb = 0 Then
                        jb = 8
                    End If
                    NNelem(i, j + 1) = nbuf(jb)
                Next j
                For j = 1 To 4
                    jb = 12 - j + 1
                    NNelem(i, j + 8) = nbuf(jb)
                Next j
                For j = 1 To 7 Step 2
                    jb = 20 - j
                    NNelem(i, j + 12) = nbuf(jb)
                    jb = jb - 1
                    If jb = 12 Then
                        jb = 20
                    End If
                    NNelem(i, j + 13) = nbuf(jb)
                Next j
            Next i
        End If

    End Sub

    Private Sub ReverseTreat3()
        '反転処理（立体）
        Dim i As Integer
        Dim b1, b2, b3 As Single

        For i = 1 To Npoint
            Select Case KindAxis
                Case 1
                    b1 = Xdata(i)
                Case 2
                    b1 = Ydata(i)
                Case 3
                    b1 = Zdata(i)
            End Select
            b2 = b1 - Vstd
            b3 = Vstd - b2
            Select Case KindAxis
                Case 1
                    Xdata(i) = b3
                Case 2
                    Ydata(i) = b3
                Case 3
                    Zdata(i) = b3
            End Select
        Next i

        Call ElemPnumReverse3() '要素の節点番号の反転（立体）

    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim ix As Integer

        If RadioButton1.Checked = True Then
            KindAxis = 1
        ElseIf RadioButton2.Checked = True Then
            KindAxis = 2
        ElseIf RadioButton5.Checked = True Then
            KindAxis = 3
        End If
        Vstd = Val(TextBox1.Text)

        Call ReverseTreat3()    '反転処理（立体）
        KdataChange5 = 1

        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New SolDDat6()  '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub SolDDat5_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        KindAxis = 1
        RadioButton1.Checked = True
        Vstd = 0
        TextBox1.Text = Str(Vstd)

    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub
End Class