'傾斜化の処理ﾌﾟﾛｸﾞﾗﾑ

Public Class SolDDat3

    Dim KindAxis As Integer     '指定座標軸（1:第1軸、2:第2軸）右手系
    Dim KindSAxis As Integer    '傾斜座標（1:X軸、2:Y軸、3:Z軸）
    Dim KindSlope As Integer    '傾斜の区分（1:一定、2:可変）
    Dim Nslope As Integer       '傾斜面の数（開始・終了面を含む）

    Dim EpsSA As Single         '開始面の傾斜座標の許容範囲
    Dim Slope1 As Single        '傾斜１
    Dim Slope2 As Single        '傾斜２
    Dim Vstd As Single          '指定座標値
    Dim VslopeAxis As Single    '開始面の傾斜座標値

    Private Sub CondDisp()
        '条件表示

        If KindSlope = 1 Then
            RadioButton4.Checked = True
            Label5.Text = "傾斜の値"
            Label8.Text = ""
            TextBox3.Visible = False
            Label9.Visible = False
            Label10.Visible = False
            Label11.Visible = False
            Label12.Visible = False
            Label15.Visible = False
            TextBox4.Visible = False
            TextBox5.Visible = False
            TextBox6.Visible = False
        Else
            RadioButton5.Checked = True
            Label5.Text = "傾斜の開始値"
            Label8.Text = "傾斜の終了値"
            TextBox3.Visible = True
            Label9.Visible = True
            Label10.Visible = True
            Label11.Visible = True
            Label12.Visible = True
            Label15.Visible = True
            TextBox4.Visible = True
            TextBox5.Visible = True
            TextBox6.Visible = True
            TextBox3.Text = Str(Slope2)
            TextBox4.Text = Str(Nslope)
            TextBox5.Text = Str(VslopeAxis)
            TextBox6.Text = Str(EpsSA)
        End If
        TextBox2.Text = Str(Slope1)
        Select Case KindSAxis
            Case 1
                RadioButton6.Checked = True
                RadioButton1.Text = "Ｙ座標"
                RadioButton2.Text = "Ｚ座標"
                Label11.Text = "開始面のＸ座標値"
            Case 2
                RadioButton7.Checked = True
                RadioButton1.Text = "Ｚ座標"
                RadioButton2.Text = "Ｘ座標"
                Label11.Text = "開始面のＹ座標値"
            Case 3
                RadioButton8.Checked = True
                RadioButton1.Text = "Ｘ座標"
                RadioButton2.Text = "Ｙ座標"
                Label11.Text = "開始面のＺ座標値"
        End Select
        If KindAxis = 1 Then
            RadioButton1.Checked = True
        Else
            RadioButton2.Checked = True
        End If
        TextBox1.Text = Str(Vstd)

    End Sub

    Private Sub SlopeTreat()
        '一定傾斜の処理
        Dim ip As Integer
        Dim b1 As Single

        For ip = 1 To Npoint
            Select Case KindSAxis
                Case 1
                    If KindAxis = 1 Then
                        b1 = Ydata(ip) - Vstd
                    Else
                        b1 = Zdata(ip) - Vstd
                    End If
                    Xdata(ip) = Xdata(ip) + b1 * Slope1
                Case 2
                    If KindAxis = 1 Then
                        b1 = Zdata(ip) - Vstd
                    Else
                        b1 = Xdata(ip) - Vstd
                    End If
                    Ydata(ip) = Ydata(ip) + b1 * Slope1
                Case 3
                    If KindAxis = 1 Then
                        b1 = Xdata(ip) - Vstd
                    Else
                        b1 = Ydata(ip) - Vstd
                    End If
                    Zdata(ip) = Zdata(ip) + b1 * Slope1
            End Select
        Next ip

    End Sub

    Private Sub SlopeTreat2()
        '可変傾斜の処理
        Dim i, ie, ip, j, jj, k, km, kk As Integer
        Dim b1, dslope, slopeb As Single
        Dim kbuf(Npoint) As Integer

        dslope = (Slope2 - Slope1) / (Nslope - 1)
        For ip = 1 To Npoint
            Select Case KindSAxis
                Case 1
                    b1 = Xdata(ip) - VslopeAxis
                Case 2
                    b1 = Ydata(ip) - VslopeAxis
                Case 3
                    b1 = Zdata(ip) - VslopeAxis
            End Select
            If Math.Abs(b1) < EpsSA Then
                kbuf(ip) = 1
                Select Case KindSAxis
                    Case 1
                        If KindAxis = 1 Then
                            b1 = Ydata(ip) - Vstd
                        Else
                            b1 = Zdata(ip) - Vstd
                        End If
                        Xdata(ip) = Xdata(ip) + b1 * Slope1
                    Case 2
                        If KindAxis = 1 Then
                            b1 = Zdata(ip) - Vstd
                        Else
                            b1 = Xdata(ip) - Vstd
                        End If
                        Ydata(ip) = Ydata(ip) + b1 * Slope1
                    Case 3
                        If KindAxis = 1 Then
                            b1 = Xdata(ip) - Vstd
                        Else
                            b1 = Ydata(ip) - Vstd
                        End If
                        Zdata(ip) = Zdata(ip) + b1 * Slope1
                End Select
            End If
        Next ip

        For i = 2 To Nslope
            slopeb = Slope2 - (Nslope - i) * dslope
            For ie = 1 To Nelem
                For j = 1 To 7 Step 2
                    k = NNelem(ie, j)
                    jj = j + 2
                    If jj > 7 Then
                        jj = 1
                    End If
                    kk = NNelem(ie, jj)
                    If kbuf(k) = i - 1 Then
                        If kbuf(kk) = 0 Then
                            kbuf(kk) = i
                        End If
                    ElseIf kbuf(kk) = i - 1 Then
                        If kbuf(k) = 0 Then
                            kbuf(k) = i
                        End If
                    End If
                    jj = j + 12
                    kk = NNelem(ie, jj)
                    If kbuf(k) = i - 1 Then
                        If kbuf(kk) = 0 Then
                            kbuf(kk) = i
                        End If
                    ElseIf kbuf(kk) = i - 1 Then
                        If kbuf(k) = 0 Then
                            kbuf(k) = i
                        End If
                    End If
                Next j
                For j = 13 To 19 Step 2
                    k = NNelem(ie, j)
                    jj = j + 2
                    If jj > 19 Then
                        jj = 13
                    End If
                    kk = NNelem(ie, jj)
                    If kbuf(k) = i - 1 Then
                        If kbuf(kk) = 0 Then
                            kbuf(kk) = i
                        End If
                    ElseIf kbuf(kk) = i - 1 Then
                        If kbuf(k) = 0 Then
                            kbuf(k) = i
                        End If
                    End If
                Next j
            Next ie
            For ie = 1 To Nelem
                For j = 1 To 7 Step 2
                    k = NNelem(ie, j)
                    jj = j + 2
                    If jj > 7 Then
                        jj = 1
                    End If
                    kk = NNelem(ie, jj)
                    If kbuf(k) = i And kbuf(kk) = i Then
                        jj = j + 1
                        kbuf(NNelem(ie, jj)) = i
                    End If
                    jj = j + 12
                    kk = NNelem(ie, jj)
                    If kbuf(k) = i And kbuf(kk) = i Then
                        Select Case j
                            Case 1
                                jj = 9
                            Case 3
                                jj = 10
                            Case 5
                                jj = 11
                            Case 7
                                jj = 12
                        End Select
                        kbuf(NNelem(ie, jj)) = i
                    End If
                Next j
                For j = 13 To 19 Step 2
                    k = NNelem(ie, j)
                    jj = j + 2
                    If jj > 19 Then
                        jj = 13
                    End If
                    kk = NNelem(ie, jj)
                    If kbuf(k) = i And kbuf(kk) = i Then
                        jj = j + 1
                        kbuf(NNelem(ie, jj)) = i
                    End If
                Next j
            Next ie
            For ip = 1 To Npoint
                If kbuf(ip) = i Then
                    Select Case KindSAxis
                        Case 1
                            If KindAxis = 1 Then
                                b1 = Ydata(ip) - Vstd
                            Else
                                b1 = Zdata(ip) - Vstd
                            End If
                            Xdata(ip) = Xdata(ip) + b1 * slopeb
                        Case 2
                            If KindAxis = 1 Then
                                b1 = Zdata(ip) - Vstd
                            Else
                                b1 = Xdata(ip) - Vstd
                            End If
                            Ydata(ip) = Ydata(ip) + b1 * slopeb
                        Case 3
                            If KindAxis = 1 Then
                                b1 = Xdata(ip) - Vstd
                            Else
                                b1 = Ydata(ip) - Vstd
                            End If
                            Zdata(ip) = Zdata(ip) + b1 * slopeb
                    End Select
                End If
            Next ip
            For ie = 1 To Nelem
                For j = 1 To 7 Step 2
                    k = NNelem(ie, j)
                    km = NNelem(ie, j + 1)
                    If kbuf(km) = 0 Then
                        jj = j + 2
                        If jj > 7 Then
                            jj = 1
                        End If
                        kk = NNelem(ie, jj)
                        If (kbuf(k) = i - 1 And kbuf(kk) = i) Or (kbuf(k) = i And kbuf(kk) = i - 1) Then
                            '隣通しの面
                            Select Case KindSAxis
                                Case 1
                                    Xdata(km) = 0.5 * (Xdata(k) + Xdata(kk))
                                Case 2
                                    Ydata(km) = 0.5 * (Ydata(k) + Ydata(kk))
                                Case 3
                                    Zdata(km) = 0.5 * (Zdata(k) + Zdata(kk))
                            End Select
                            kbuf(km) = -1
                        End If
                    End If
                    Select Case j
                        Case 1
                            km = NNelem(ie, 9)
                        Case 3
                            km = NNelem(ie, 10)
                        Case 5
                            km = NNelem(ie, 11)
                        Case 7
                            km = NNelem(ie, 12)
                    End Select
                    If kbuf(km) = 0 Then
                        kk = NNelem(ie, j + 12)
                        If (kbuf(k) = i - 1 And kbuf(kk) = i) Or (kbuf(k) = i And kbuf(kk) = i - 1) Then
                            '隣通しの面
                            Select Case KindSAxis
                                Case 1
                                    Xdata(km) = 0.5 * (Xdata(k) + Xdata(kk))
                                Case 2
                                    Ydata(km) = 0.5 * (Ydata(k) + Ydata(kk))
                                Case 3
                                    Zdata(km) = 0.5 * (Zdata(k) + Zdata(kk))
                            End Select
                            kbuf(km) = -1
                        End If
                    End If
                Next j
                For j = 13 To 19 Step 2
                    k = NNelem(ie, j)
                    km = NNelem(ie, j + 1)
                    If kbuf(km) = 0 Then
                        jj = j + 2
                        If jj > 19 Then
                            jj = 13
                        End If
                        kk = NNelem(ie, jj)
                        If (kbuf(k) = i - 1 And kbuf(kk) = i) Or (kbuf(k) = i And kbuf(kk) = i - 1) Then
                            '隣通しの面
                            Select Case KindSAxis
                                Case 1
                                    Xdata(km) = 0.5 * (Xdata(k) + Xdata(kk))
                                Case 2
                                    Ydata(km) = 0.5 * (Ydata(k) + Ydata(kk))
                                Case 3
                                    Zdata(km) = 0.5 * (Zdata(k) + Zdata(kk))
                            End Select
                            kbuf(km) = -1
                        End If
                    End If
                Next j
            Next ie
        Next i

    End Sub

    Private Sub ValStore()
        '数値保存
        Vstd = Val(TextBox1.Text)
        Slope1 = Val(TextBox2.Text)
        Slope2 = Val(TextBox3.Text)
        Nslope = Val(TextBox4.Text)
        VslopeAxis = Val(TextBox5.Text)
        EpsSA = Val(TextBox6.Text)

    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim ix As Integer

        If RadioButton6.Checked = True Then
            KindSAxis = 1
        ElseIf RadioButton7.Checked = True Then
            KindSAxis = 2
        Else
            KindSAxis = 3
        End If
        If RadioButton1.Checked = True Then
            KindAxis = 1
        Else
            KindAxis = 2
        End If
        Call ValStore()     '数値保存
        If KindSlope = 2 Then
            If Nslope < 2 Then
                aa$ = "傾斜面の数が不足です！"
                MsgBox(aa$, 0, "設定エラー")
                Exit Sub
            End If
        End If

        If KindSlope = 1 Then
            Call SlopeTreat()     '一定傾斜の処理
        Else
            Call SlopeTreat2()    '可変傾斜の処理
        End If

        KdataChange5 = 1

        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New SolDDat6  '立体ﾃﾞｰﾀﾌｧｲﾙ出力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub SolDDat3_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        KindSlope = 1
        KindSAxis = 3
        KindAxis = 1
        Vstd = 0

        Call CondDisp()     '条件表示

    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub

    Private Sub RadioButton4_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton4.Click
        If KindSlope = 2 Then
            KindSlope = 1
            Call CondDisp()     '条件表示
        End If
    End Sub

    Private Sub RadioButton5_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton5.Click
        If KindSlope = 1 Then
            KindSlope = 2
            Call CondDisp()     '条件表示
        End If
    End Sub

    Private Sub RadioButton6_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton6.Click
        If KindSAxis > 1 Then
            KindSAxis = 1
            Call ValStore()     '数値保存
            Call CondDisp()     '条件表示
        End If
    End Sub

    Private Sub RadioButton7_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton7.Click
        If KindSAxis <> 2 Then
            KindSAxis = 2
            Call ValStore()     '数値保存
            Call CondDisp()     '条件表示
        End If

    End Sub

    Private Sub RadioButton8_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton8.Click
        If KindSAxis < 3 Then
            KindSAxis = 3
            Call ValStore()     '数値保存
            Call CondDisp()     '条件表示
        End If

    End Sub
End Class